#ifndef _BITMAP_H_
#define _BITMAP_H_
#include <stdint.h>

class bitmap_t{
public:
    bitmap_t():data(0){};
    ~bitmap_t(void);
    uint8_t *data;//can we use uint32_t??
    size_t   size;//# of uint*_t element
    size_t   nbits;//# of bit 1 in data.
    //check if processor peId has isoblock by referencing bitmap
    bool isSet(int peId) const{
        int myelement = peId / 8;
        int mybit     = peId % 8;
        return (((data[myelement] >> mybit)&0x01) != 0);
    }
    void set(int peId){
        int myelement   = peId / 8;
        int mybit       = peId % 8;
        uint8_t mycode  = 1 << (/*7 -*/ mybit);
        data[myelement] = mycode;
    }
    size_t count_num_dirty_bit();
};

#endif

