#ifndef VERTEX_TRIANGLE_H
#define VERTEX_TRIANGLE_H
#include "vec3f.h"

int __vertex_compare(const void *pa,const void *pb);

class vertex_triangle_t
{
public:
    size_t m_idx_triangle;//the index of triangle that has this vertex.
    int m_local_idx;//which one of the three vertices is this vertex in the triangle[m_idex_triangle].
    lily::vec3f m_coord;//coordinates of the vertex.
    vertex_triangle_t(void):m_idx_triangle(-1),m_local_idx(-1),m_coord(0.0f){};

    vertex_triangle_t(const lily::vec3f& coord, const int local_idx, const size_t idx_triangle)
        : m_coord(coord),m_local_idx(local_idx),m_idx_triangle(idx_triangle){};
    ~vertex_triangle_t(void);

    friend int __vertex_compare(const void *pa,const void *pb);
};
#endif
