#include <stdlib.h>
#include "dutility.h"
#include "bitmap_t.h"

bitmap_t::~bitmap_t( void )
{
    if (data){
        free(data);
        data = NULL;
    }
}

size_t bitmap_t::count_num_dirty_bit()
{
//Count the # of processor which contains isovoxels.
    size_t i, mapsize = size;
    size_t bit_count=0;
    for (i = 0; i < mapsize ; i++){
        //Scan the gmap in a chunk of 8bits as step size.
        //and count the number of bit 1 in a chunk by looking up the table.
        bit_count += bit_count_table[data[i]];//count the number of bit 1.
    }
    return bit_count;
}


